<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="ru">
<head>
<!-- Generated by javadoc (1.8.0_151) on Sat Jun 15 11:41:18 MSK 2019 -->
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>LineUtils</title>
<meta name="date" content="2019-06-15">
<link rel="stylesheet" type="text/css" href="../../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="LineUtils";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":9,"i1":9,"i2":9,"i3":9};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../com/playground/drawingar/rendering/LineShaderRenderer.html" title="class in com.playground.drawingar.rendering"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../com/playground/drawingar/rendering/PointCloudRenderer.html" title="class in com.playground.drawingar.rendering"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?com/playground/drawingar/rendering/LineUtils.html" target="_top">Frames</a></li>
<li><a href="LineUtils.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">com.playground.drawingar.rendering</div>
<h2 title="Class LineUtils" class="title">Class LineUtils</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>com.playground.drawingar.rendering.LineUtils</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<br>
<pre>public class <span class="typeNameLabel">LineUtils</span>
extends java.lang.Object</pre>
<div class="block">Вспомогательный класс, реализующий алгоритм проекции геометрический
 фигур на объекты окружающей среды.</div>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Constructor Summary table, listing constructors, and an explanation">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colOne" scope="col">Constructor and Description</th>
</tr>
<tr class="altColor">
<td class="colOne"><code><span class="memberNameLink"><a href="../../../../com/playground/drawingar/rendering/LineUtils.html#LineUtils--">LineUtils</a></span>()</code>&nbsp;</td>
</tr>
</table>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>static javax.vecmath.Vector3f</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../com/playground/drawingar/rendering/LineUtils.html#GetWorldCoords-javax.vecmath.Vector2f-com.google.ar.core.Pose-float-float-float:A-float:A-">GetWorldCoords</a></span>(javax.vecmath.Vector2f&nbsp;touchPoint,
              com.google.ar.core.Pose&nbsp;planePose,
              float&nbsp;screenWidth,
              float&nbsp;screenHeight,
              float[]&nbsp;projectionMatrix,
              float[]&nbsp;viewMatrix)</code>
<div class="block">Возвращает координаты точки в мировом пространстве.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>private static float[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../com/playground/drawingar/rendering/LineUtils.html#multiplyMV-float:A-float:A-">multiplyMV</a></span>(float[]&nbsp;mat,
          float[]&nbsp;vec)</code>
<div class="block">Умножает матрицу 6 x 4 на вектор 6.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>private static <a href="../../../../com/playground/drawingar/model/Ray.html" title="class in com.playground.drawingar.model">Ray</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../com/playground/drawingar/rendering/LineUtils.html#projectRay-javax.vecmath.Vector2f-float-float-float:A-float:A-">projectRay</a></span>(javax.vecmath.Vector2f&nbsp;touchPoint,
          float&nbsp;screenWidth,
          float&nbsp;screenHeight,
          float[]&nbsp;projectionMatrix,
          float[]&nbsp;viewMatrix)</code>
<div class="block">Возвращает луч, брошенный с точки касания экрана.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>private static <a href="../../../../com/playground/drawingar/model/Ray.html" title="class in com.playground.drawingar.model">Ray</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../../com/playground/drawingar/rendering/LineUtils.html#screenPointToRay-javax.vecmath.Vector2f-javax.vecmath.Vector2f-float:A-">screenPointToRay</a></span>(javax.vecmath.Vector2f&nbsp;point,
                javax.vecmath.Vector2f&nbsp;viewportSize,
                float[]&nbsp;viewProjMtx)</code>
<div class="block">Возвращает луч, брошенный с точки касания экрана.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<ul class="blockList">
<li class="blockList"><a name="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a name="LineUtils--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>LineUtils</h4>
<pre>public&nbsp;LineUtils()</pre>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="GetWorldCoords-javax.vecmath.Vector2f-com.google.ar.core.Pose-float-float-float:A-float:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>GetWorldCoords</h4>
<pre>public static&nbsp;javax.vecmath.Vector3f&nbsp;GetWorldCoords(javax.vecmath.Vector2f&nbsp;touchPoint,
                                                    com.google.ar.core.Pose&nbsp;planePose,
                                                    float&nbsp;screenWidth,
                                                    float&nbsp;screenHeight,
                                                    float[]&nbsp;projectionMatrix,
                                                    float[]&nbsp;viewMatrix)</pre>
<div class="block">Возвращает координаты точки в мировом пространстве.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>touchPoint</code> - Координаты точки на экране.</dd>
<dd><code>planePose</code> - Рлоскость, на которую проецируется точка.</dd>
<dd><code>screenWidth</code> - Ширина экрана.</dd>
<dd><code>screenHeight</code> - Высота экрана.</dd>
<dd><code>projectionMatrix</code> - Матрица проекции.</dd>
<dd><code>viewMatrix</code> - Матрица вида.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Вектор с координатами точки в мировом пространстве.</dd>
</dl>
</li>
</ul>
<a name="multiplyMV-float:A-float:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>multiplyMV</h4>
<pre>private static&nbsp;float[]&nbsp;multiplyMV(float[]&nbsp;mat,
                                  float[]&nbsp;vec)</pre>
<div class="block">Умножает матрицу 6 x 4 на вектор 6.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>mat</code> - Матрица 6 x 4.</dd>
<dd><code>vec</code> - Вектор 6.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Вектор 4.</dd>
</dl>
</li>
</ul>
<a name="screenPointToRay-javax.vecmath.Vector2f-javax.vecmath.Vector2f-float:A-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>screenPointToRay</h4>
<pre>private static&nbsp;<a href="../../../../com/playground/drawingar/model/Ray.html" title="class in com.playground.drawingar.model">Ray</a>&nbsp;screenPointToRay(javax.vecmath.Vector2f&nbsp;point,
                                    javax.vecmath.Vector2f&nbsp;viewportSize,
                                    float[]&nbsp;viewProjMtx)</pre>
<div class="block">Возвращает луч, брошенный с точки касания экрана.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>point</code> - Координаты точки касания экрана.</dd>
<dd><code>viewportSize</code> - Размер экрана.</dd>
<dd><code>viewProjMtx</code> - Матрица, полученная перемножением матриц вида и проекции.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Луч, представляющий собой направление и точку, через которую брошен луч.</dd>
</dl>
</li>
</ul>
<a name="projectRay-javax.vecmath.Vector2f-float-float-float:A-float:A-">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>projectRay</h4>
<pre>private static&nbsp;<a href="../../../../com/playground/drawingar/model/Ray.html" title="class in com.playground.drawingar.model">Ray</a>&nbsp;projectRay(javax.vecmath.Vector2f&nbsp;touchPoint,
                              float&nbsp;screenWidth,
                              float&nbsp;screenHeight,
                              float[]&nbsp;projectionMatrix,
                              float[]&nbsp;viewMatrix)</pre>
<div class="block">Возвращает луч, брошенный с точки касания экрана.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>touchPoint</code> - Координаты точки касания экрана.</dd>
<dd><code>screenWidth</code> - Ширина экрана.</dd>
<dd><code>screenHeight</code> - Высота экрана.</dd>
<dd><code>projectionMatrix</code> - Матрица проекции.</dd>
<dd><code>viewMatrix</code> - Матрица вида.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Луч, представляющий собой направление и точку, через которую брошен луч.</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../../index-files/index-1.html">Index</a></li>
<li><a href="../../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../../com/playground/drawingar/rendering/LineShaderRenderer.html" title="class in com.playground.drawingar.rendering"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../../com/playground/drawingar/rendering/PointCloudRenderer.html" title="class in com.playground.drawingar.rendering"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../../index.html?com/playground/drawingar/rendering/LineUtils.html" target="_top">Frames</a></li>
<li><a href="LineUtils.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li>Field&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</body>
</html>
